const Gio = imports.gi.Gio;
const Extension = imports.misc.extensionUtils.getCurrentExtension();

function getSettings(schema)
{
    const GioSSS = Gio.SettingsSchemaSource;

    let schemaDir = Extension.dir.get_child('schemas');
    let schemaSource;
    if (schemaDir.query_exists(null))
	schemaSource = GioSSS.new_from_directory(schemaDir.get_path(), GioSSS.get_default(), false);
    else
	schemaSource = GioSSS.get_default();
    
    let schemaObj = schemaSource.lookup(schema, true);
    if (! schemaObj)
	throw new Error('Schema ' + schema + ' could not be found for extension ' + Extension.metadata.uuid + '. Please check your installation.');
    
    return new Gio.Settings({settings_schema: schemaObj})
}
